<template>
	<div class="container stream">

			<h1 class="section--stream__title">Lorem ipsum dolor sit</h1>

			<div class="section--stream__video">

			</div>

			<div class="row">
				<div class="col-xl-8">
					<div class="text-block section--stream__text">
						<p>Lorem ipsum dolor sit amet consectetur adipisicing elit. Reprehenderit, quos porro. Quia mollitia quis ratione minus repellendus cum quam sapiente voluptatibus, necessitatibus, dolore ullam harum neque sunt illum tempora error?</p>
						<p>Et iste quasi eos totam ad, laboriosam vero dolorum cupiditate. Atque, esse explicabo sed mollitia sint facere quisquam delectus repellendus ipsa, sequi quasi a qui rerum itaque id tempore aspernatur.</p>
						<p>Aut magnam sapiente, fugit rem non labore in porro beatae illum laboriosam atque dicta, debitis repudiandae nihil, soluta nisi deserunt ducimus cumque molestias asperiores adipisci commodi. Corporis voluptates laborum vero.</p>
					</div>
				</div>
				<div class="col-xl-4">
					<div class="section--stream__sidebar">
						<div class="section--stream__speakers">
							<h2 class="section--stream__speakers__title">Спикеры:</h2>

							<div class="section--stream__speaker">
								<img src="/valery.jpeg" alt="Валерий Алексеев" class="section--stream__speaker__photo">
								<div class="section--stream__speaker__name">Валерий Алексеев</div>
								<div class="section--stream__speaker__text">Дизайнер, руководитель Школы #VA</div>
								<div class="section--stream__speaker__socials">
									<a href="https://instagram.com/valery_alexeev" target="_blank">Instagram</a>
									<a href="https://youtube.com/va_promotion" target="_blank">YouTube</a>
									<a href="https://behance.net/valery-alexeev" target="_blank">Behance</a>
								</div>
							</div>
						</div>

						<!-- <div class="section--stream__links" v-if="content.links && content.links.length">
							<h2 class="section--stream__links__title">Ссылки:</h2>
							<ul>
								<li v-for="l, i in content.links" :key="i"><a target="_blank" :href="l.url">{{ l.title }}</a> — {{ l.text }}</li>
							</ul>
						</div> -->
					</div>
				</div>
			</div>



















		<div v-if="isBefore || isAfterReset">Следующая лекция: {{ nextStart }}</div>

		<div v-else-if="isLive">
			<div class="row justify-content-center">
				<div class="col-12">
					<section-title text="Lorem ipsum dolor sit, amet consectetur adipisicing elit. Hic pariatur explicabo recusandae?" title="Lorem ipsum <mark>dolor sit amet</mark> consectetur." />

				</div>
			</div>
			<div class="row">
				<div class="col-lg-7"></div>
				<div class="col-lg-5">
					<div class="stream__comments">
						<h4 class="stream__comments__title">Комментарии:</h4>
						<div class="stream__comments__subtitle">Lorem ipsum dolor sit amet consectetur, adipisicing elit. Maxime ad fugiat molestias omnis eius quaerat ut natus asperiores expedita alias.</div>

						<div class="stream__comments__item" v-for="(c,i) in comments" :key="i">
							<div class="stream__comments__item__name">{{ c.name }}</div>
							<div class="stream__comments__item__text">{{ c.text }}</div>
						</div>

					</div>
				</div>
			</div>
		</div>

		<div v-else-if="isAfter">Лекция завершена</div>

		{{ untilNext }}


	</div>
</template>

<script>
import moment from 'moment-timezone';
import VaButton from '../components/ui/VaButton.vue';
import SectionTitle from '../components/ui/SectionTitle.vue';
import Plyr from "plyr";

export default {
  components: { VaButton, SectionTitle },
	data() {
		return {
			comments: [],


			embed: '<h1>test</h1>',








			// tz: 'Europe/Moscow',


		}
	},

	created() {
		moment.tz.setDefault(this.tz);

		this.updateStates();
		setInterval(() => {
			this.updateStates();
		}, 1000);
	},

	mounted() {
		this.player = new Plyr('#player', {
			controls: ['fullscreen'],
			loadSprite: false,
			clickToPlay: false,
			hideControls: false
		});


		setInterval(() => {
			this.updateComments();
		}, 2000);

		// this.$refs.video.controls = false;
	},

	computed: {
		nextStart() {
			let now = moment(),
				nextStart = moment().set(this.startsAt);

			// Если NextStart в прошлом, увеличиваем на один день
			if (nextStart.isBefore(now)) {
				nextStart.add(1, 'day');
			}

			return nextStart;
		},

		formattedPlayTime() {
			let d = this.secondsPlayed;
			let played = {
				h: Math.floor(d / 3600),
    			m: Math.floor(d % 3600 / 60),
    			s: Math.floor(d % 3600 % 60)
			};
			return played.h + ':' + (played.m > 9 ? played.m : '0' + played.m) + ':' + (played.s > 9 ? played.s : '0' + played.s);
		}

		// state() {
		// 	if (this.isLive) {
		// 		return 'live';
		// 	}

		// 	if (this.isBefore)

		// 	let now = moment(),
		// 		endMoment = moment().set(this.startsAt).add(this.length),
		// 		resetMoment = moment().set(this.startsAt).add(this.length).add(this.resetAfter);


		// }
	},

	methods: {
		// connect() {
		// 	let v = this.$refs.video;
		// 	this.isLoading = true;

		// 	v.currentTime = this.secondsPlayed;

		// 	v.addEventListener("canplay", () => {
		// 		this.isPlaying = true;
		// 		this.isLoading = false;
		// 	});

		// 	v.addEventListener('loadedmetadata', () => {
		// 		v.currentTime = this.secondsPlayed;
		// 	});

		// 	v.play();

		// },
		connect() {
			this.isLoading = true;

			this.player.on('playing', () => {
				this.isPlaying = true;
				this.isLoading = false;
			});

			this.player.play();
			this.player.currentTime = this.secondsPlayed;
		},
		updateStates() {
			let now = moment(),
				startMoment = moment().set(this.startsAt),
				endMoment = moment().set(this.startsAt).add(this.length).add(4, 'second');

			this.isLive = now.isBetween(startMoment, endMoment);
			this.isBefore = now.isBefore(startMoment);
			this.isAfter = now.isAfter(endMoment);
			this.isAfterReset = now.isAfter(endMoment.add(this.resetAfter));
			this.secondsPlayed = this.isLive ? Math.floor(now.diff(startMoment) / 1000) : 0;

			let d = Math.floor(this.nextStart.diff(now) / 1000);
			this.untilNext = this.isBefore ? {
				h: Math.floor(d / 3600),
    			m: Math.floor(d % 3600 / 60),
    			s: Math.floor(d % 3600 % 60)
			} : null;
		},

		updateComments() {

			for (var timestamp in this.autocomments) {
				var comment = this.autocomments[timestamp],
					ts = timestamp.split(":"),
					seconds = (+ts[0]) * 60 * 60 + (+ts[1]) * 60 + (+ts[2]);

				if (this.secondsPlayed >= seconds) {
					this.$delete(this.autocomments, timestamp);
					this.comments.push(comment);
				}
				console.log(seconds);
			}

		}
	}
}
</script>
